' MxLoader Updater

MXVER = "8.4.2"

WScript.echo "MxLoader Updater tool version " + MXVER
WScript.echo

msgBoxTitle = "MxLoaderUpdater " + MXVER

msgBoxText = "This utility will update an MxLoader file to version " + MXVER + vbCrLf
msgBoxText = msgBoxText + "Input file must be version 8 or greater." + vbCrLf

msgRet = MsgBox(msgBoxText, vbOKCancel, msgBoxTitle)

if msgRet=vbCancel Then
    WScript.echo "Canceled"
	WScript.echo
	WScript.Quit (0)
End If

Set objFs = WScript.CreateObject("Scripting.FileSystemObject")
Set objShell = CreateObject("Shell.Application")
Set objScripShell = CreateObject("WScript.Shell")

' displays file selection dialog
Set oExec = objScripShell.Exec("mshta.exe ""about:<input type=file id=FILE><script>FILE.click();new ActiveXObject('Scripting.FileSystemObject').GetStandardStream(1).WriteLine(FILE.value);close();resizeTo(0,0);</script>""")

fileIn = oExec.StdOut.ReadLine

' exit if no file is selected
If fileIn = "" Then
    WScript.echo "No file selected"
	WScript.echo
    WScript.Quit (1)
End If

' check file extension
If Right(fileIn, 5) <> ".xlsm" Then
    WScript.echo "Please select an MxLoader file with xlsm extension"
	WScript.echo
    WScript.Quit (1)
End If


currDir = CreateObject("Scripting.FileSystemObject").GetParentFolderName(WScript.ScriptFullName)
'tmpDir = currDir & "\tmp"
tmpDir = CreateObject("Scripting.FileSystemObject").GetSpecialFolder(2) & "\MxLoaderUpdater"
tmpDir2 = tmpDir & "\xls"

fileBck = Left(fileIn, Len(fileIn)-5) & "_old.xlsm"

tmpZipFile = tmpDir & "\tmp.zip"
updaterFile = currDir & "\MxLoaderUpdater.zip"

wscript.echo "Input File  : " & fileIn
wscript.echo "Backup File : " & fileBck
'wscript.echo "Updater : " & updaterFile
wscript.echo "Temp dir    : " & tmpDir
wscript.echo


' exit output file exists
If objFs.FileExists(fileBck) Then
    WScript.echo "Backup file already exists: " & fileBck
    WScript.echo "Delete it before launching MxLoader Updater."
	WScript.echo
    WScript.Quit (2)
End If

'wscript.echo "Creating temp directories"

If objFs.FolderExists(tmpDir) Then
    objFs.DeleteFolder tmpDir, True
End If
If not objFs.FolderExists(tmpDir) Then objFs.CreateFolder(tmpDir)
If not objFs.FolderExists(tmpDir2) Then objFs.CreateFolder(tmpDir2)


wscript.echo "Creating backup file"
objFs.CopyFile fileIn, fileBck


'wscript.echo "Copying source file to temp dir"

objFs.CopyFile fileIn, tmpZipFile

wscript.echo "Extracting file to temp dir"

Set FilesInZip = objShell.NameSpace(tmpZipFile).items
objShell.NameSpace(tmpDir2).CopyHere FilesInZip, 4+16


wscript.echo "Patching"

Set FilesInZip = objShell.NameSpace(updaterFile).items
objShell.NameSpace(tmpDir2).CopyHere FilesInZip, 4+16


wscript.echo "Creating output file"

objFs.DeleteFile (tmpZipFile)

set f1 = objFs.CreateTextFile(tmpZipFile, True)
f1.Write Chr(80) & Chr(75) & Chr(5) & Chr(6) & String(18, chr(0))
f1.close

Set zip = objShell.NameSpace(tmpZipFile)
Set Fol = objShell.NameSpace(tmpDir2)
zip.CopyHere Fol.Items, 4+16
Do Until zip.Items.Count = Fol.Items.Count
    WScript.Sleep 1000
Loop


'wscript.echo "Copying output file"

objFs.CopyFile tmpZipFile, fileIn

' remove temp folder

objFs.DeleteFolder tmpDir, True

Set objFs = Nothing
Set objShell = Nothing


wscript.echo "Done"
wscript.echo
